using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using WindowsApplication1;
using System.IO;
using System.Xml;
using System.Web;


namespace Filmverwaltung
{
    public partial class FilmlisteForm : Form
    {
        public ArrayList Filme = new ArrayList();
        FilmverwaltungForm FilmverwaltungForm1;
        String Datei;
        public Boolean gespeichert = true;
        int Reihe;
        public BindingSource FilmFilter = new BindingSource();
        public Hashtable language = new Hashtable();

        public FilmlisteForm()
        {
            FilmverwaltungForm1 = new FilmverwaltungForm(Filme, this);         
            InitializeComponent();
        }

        private void FilmlisteForm_Shown(object sender, EventArgs e)
        {
            //MessageBox.Show(weite.ToString());
        }

        public void GriedViwe_selectieren(int i)
        {
            //int index = 
            //FilmdataGridView.CurrentCell = i;
        }
        public void GridView_fuellen(ArrayList Filme)
        {
            if (Filme != null)
            {
                //FilmdataGridView.Columns.Add("Titel", test);
                FilmdataGridView.DataSource = FilmDatenSource();
                for (int i = 0; i < FilmdataGridView.Columns.Count; i++)
                {
                    FilmdataGridView.Columns[i].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                }

                Filmanzahllabel.Text = language["labelAnzahlFilme"].ToString() + Filme.Count.ToString();
            }
        }

        private void schliessenbutton_Click(object sender, EventArgs e)
        {
            DialogResult result;

            if (gespeichert == false)
            {
                result = MessageBox.Show(language["errorSpeichernSchliessen"].ToString(), "Speichermeldung", MessageBoxButtons.YesNo);

                if (result == DialogResult.Yes) this.Close();
            }
            else this.Close();
        }

        private void exportbutton_Click(object sender, EventArgs e)
        {
            export();
        }

        private void neueFilmlisteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Filme = new ArrayList();
            Datei = "";
            FilmverwaltungForm FilmverwaltungForm1 = new FilmverwaltungForm(Filme, this);
            FilmverwaltungForm1.Show();
            this.Visible = false;

            freigabeEdit();
        }

        private void filmlisteffnenToolStripMenuItem_Click(object sender, EventArgs e)
        {

            this.openFileDialog1.InitialDirectory = Application.StartupPath;
            this.openFileDialog1.Filter = language["FiledataXML"].ToString();
            this.openFileDialog1.FilterIndex = 2;
            this.openFileDialog1.FileName = "";
            this.openFileDialog1.RestoreDirectory = true;

            if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                if (this.openFileDialog1.OpenFile() != null)
                {
                    //Filme.Insert(Filme.Count, FormverwaltungForm1.datei_oeffnen(this.openFileDialog1.FileName));
                    Filme=FilmverwaltungForm1.datei_oeffnen(this.openFileDialog1.FileName);
                    GridView_fuellen(Filme);
                    Datei = this.openFileDialog1.FileName;
                    this.Text = "Filmverwaltung - " + this.openFileDialog1.FileName;
                }
            }

            freigabeEdit();

        }

        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult result;

            if (gespeichert == false)
            {
                result = MessageBox.Show(language["errorSpeichernSchliessen"].ToString(), "Speichermeldung", MessageBoxButtons.YesNo);

                if (result == DialogResult.Yes) this.Close();
            }
            else this.Close();
        }

        private void export()
        {

            this.saveFileDialog1.Filter = language["FiledataText"].ToString();
            this.saveFileDialog1.FilterIndex = 1;

            if (this.saveFileDialog1.ShowDialog() == DialogResult.OK)
            {

                FileStream dateiattribute = new FileStream(this.saveFileDialog1.FileName, FileMode.Create);
                StreamWriter dateis = new StreamWriter(dateiattribute);

                if (Filme.Count != 0)
                {
                    dateis.WriteLine(language["exportTiteltext"].ToString());
                    dateis.WriteLine("--------------------------------------------");
                    foreach (object s in Filme)
                    {
                        Film speichern = (Film)s;
                        dateis.Write(speichern.titel + "\t");
                        dateis.Write(speichern.anzahl + " ");
                        dateis.Write(speichern.art + "\t");
                        dateis.Write(speichern.format + "\t");
                        dateis.WriteLine(speichern.bewertung + "\t");
                        dateis.WriteLine(speichern.staffel + "\t");
                        dateis.WriteLine(speichern.episode + "\t");
                        dateis.WriteLine(speichern.episodentitel + "\t");
                        //dateis.WriteLine(speichern.beschreibung + "\t");
                    }
                }
                else MessageBox.Show(language["errorSpeichern"].ToString());

                dateis.Close();
                dateiattribute.Close();
            }
        }

        private void freigabeEdit()
        {
            filmBearbeitenToolStripMenuItem.Enabled = true;
            filmLschenToolStripMenuItem.Enabled = true;
            filmHinzufgenToolStripMenuItem.Enabled = true;
            hinzubutton.Enabled = true;
            
        }

        private void filmExportierenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            export();
        }

        private void speichernbutton_Click(object sender, EventArgs e)
        {
            if ((Datei != "") && (Datei != null)) FilmverwaltungForm1.datei_speichern(Datei, Filme);
            else
            {
                this.saveFileDialog1.Filter = language["FiledataXML"].ToString();
                this.saveFileDialog1.FilterIndex = 1;
                if (this.saveFileDialog1.ShowDialog() == DialogResult.OK) FilmverwaltungForm1.datei_speichern(saveFileDialog1.FileName, Filme);
                Datei = saveFileDialog1.FileName;
            }        
        }

        private void filmlisteSpeichernToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if ((Datei != "") && Datei != null) FilmverwaltungForm1.datei_speichern(Datei, Filme);
            else
            {
                this.saveFileDialog1.Filter = language["FiledataXML"].ToString();
                this.saveFileDialog1.FilterIndex = 1;
                if (this.saveFileDialog1.ShowDialog() == DialogResult.OK) FilmverwaltungForm1.datei_speichern(saveFileDialog1.FileName, Filme);
            }        
        }

        private void filmlisteSpeichernUnterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.saveFileDialog1.Filter = language["FiledataXML"].ToString();
                this.saveFileDialog1.FilterIndex = 1;
                if (this.saveFileDialog1.ShowDialog() == DialogResult.OK) FilmverwaltungForm1.datei_speichern(saveFileDialog1.FileName, Filme);
        }

        private void hinzubutton_Click(object sender, EventArgs e)
        {
            if ((Datei != null))
            {
                FilmverwaltungForm FilmverwaltungForm1 = new FilmverwaltungForm(Filme, this);
                FilmverwaltungForm1.Show();
                this.Visible = false;
            }
            else MessageBox.Show(language["errorFilmhinzu"].ToString());
        }

        private void filmBearbeitenToolStripMenuItem_Click(object sender, EventArgs e)
        {            
            if ((Filme.Count > 0) && (Reihe < Filme.Count) && (Datei != null))
            {                
                //String test = FilmdataGridView.Rows[Reihe].Cells[0].ToString();
                FilmverwaltungForm FilmverwaltungForm1 = new FilmverwaltungForm(Filme, this);
                FilmverwaltungForm1.Filmbearbeiten(Reihe);
                FilmverwaltungForm1.Show();
                this.Visible = false;
            }
        }

        private void FilmdataGridView_RowEnter(object sender, DataGridViewCellEventArgs e)
        {
            //Reihe = e.RowIndex;
            String Reihe2 = (string)FilmdataGridView.Rows[e.RowIndex].Cells[0].Value;
            Reihe = Convert.ToInt32(Reihe2)-1;
        }

        private void filmLschenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Film weg = (Film) Filme[Reihe];
            DialogResult result;

            result = MessageBox.Show(language["errorLoeschen"].ToString() + weg.titel, "Lschen", MessageBoxButtons.YesNo);

                if (result == DialogResult.Yes)
                {
                    gespeichert = false;
                    Filme.Remove(weg);
                    GridView_fuellen(Filme);
                }

        }

        private void filmeHinzufgenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if ((Datei != null))
            {
                FilmverwaltungForm FilmverwaltungForm1 = new FilmverwaltungForm(Filme, this);
                FilmverwaltungForm1.Show();
                this.Visible = false;
            }
            else MessageBox.Show(language["errorFilmhinzu"].ToString());

        }

        private void creditsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Filmverwaltung\nRelease 1.2 \nFreeware \n\n  Programmiert von: \n  Michael Dpjohann \n\n www.md-technologie.de", "Credits");
        }

        private void hilfeToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            //MessageBox.Show("Dies guckt sich doch eh kein Mensch an, oder?\nAuerdem sollte alles selbsterklrend sein :)\n\nFalls es doch noch Fragen gibt, geht auf meine Homepage\n www.md-technologie.de\nund stellt dort die Fragen.", "Hilfe oder so");

            String Zeile, information;
            information = "";
            FileStream fs = new FileStream(@"Hilfe.txt", FileMode.OpenOrCreate, FileAccess.Read);
            StreamReader r = new StreamReader(fs, System.Text.Encoding.Default);

            //Zeiger auf den Anfang
            r.BaseStream.Seek(0, SeekOrigin.Begin);
            while (r.Peek() > -1) {
                Zeile = r.ReadLine();
                information += (Zeile.ToString() + "\n");
            };
            r.Close();
            fs.Close();
            MessageBox.Show(information.ToString());
            
        }

        private void filmSuchenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SuchForm suchform = new SuchForm(this);
            if (Filme.Count > 0)
                suchform.Show();
            else MessageBox.Show("Es existieren keine zu durchsuchenden Filme");
            
        }

        private DataTable FilmDatenSource() 
        {
                Filme.Sort();

                DataTable movies = new DataTable();

                movies.Columns.Add("Nr.");
                movies.Columns.Add("Titel");
                movies.Columns.Add("Sprache");
                movies.Columns.Add("Art");
                movies.Columns.Add("Anzahl");
                movies.Columns.Add("Format");
                movies.Columns.Add("Bewertung");
                movies.Columns.Add("Staffel");
                movies.Columns.Add("Episode");
                movies.Columns.Add("Episodentitel");
                movies.Columns.Add("Beschreibung");

                int nr = 1; ;
                foreach (Film film in Filme)
                {
                    //movies.Rows.Add(film);
                    movies.Rows.Add(new Object[] { nr.ToString(), film.titel, film.sprache, film.art, film.anzahl, film.format, film.bewertung, film.staffel, film.episode, film.episodentitel, film.beschreibung });
                    nr++;
                }

            return movies;
        
        }


        private void SuchFilterTextBox_TextChanged(object sender, EventArgs e)
        {
            String Filter = "";

            if (Filme.Count != 0)
            {                
                FilmFilter.DataSource = FilmDatenSource();
                FilmdataGridView.DataSource = FilmFilter;
                Filter = "Titel like'%" + SuchFilterTextBox.Text + "%'";

            }

            if (FilmecheckBox.Checked) { Filter += "AND Staffel = 0"; }
            if (SeriencheckBox.Checked) {Filter += "AND Staffel > 0"; }

            FilmFilter.Filter = Filter;
        }

        private void importAlteListeToolStripMenuItem_Click(object sender, EventArgs e)
        {

            this.openFileDialog1.InitialDirectory = Application.StartupPath;
            this.openFileDialog1.Filter = "xml Dateien (*.xml)|*.xml";
            this.openFileDialog1.FilterIndex = 2;
            this.openFileDialog1.FileName = "";
            this.openFileDialog1.RestoreDirectory = true;

            if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                if (this.openFileDialog1.OpenFile() != null)
                {
                    //Filme.Insert(Filme.Count, FormverwaltungForm1.datei_oeffnen(this.openFileDialog1.FileName));
                    Filme = FilmverwaltungForm1.datei_oeffnenAlt(this.openFileDialog1.FileName);
                    GridView_fuellen(Filme);
                    Datei = this.openFileDialog1.FileName;
                    this.Text = "Filmverwaltung - " + this.openFileDialog1.FileName;
                }
            }

            freigabeEdit();


        }

        private void FilmlisteForm_Load(object sender, EventArgs e)
        {
            this.setLanguage();

            dateiToolStripMenuItem.Text = language["MenuDatei"].ToString();
            bearbeitenToolStripMenuItem.Text = language["MenuEdit"].ToString();
            hilfeToolStripMenuItem.Text = language["MenuHelp"].ToString();

            neueFilmlisteToolStripMenuItem.Text = language["MenuFilmneu"].ToString();
            filmlisteffnenToolStripMenuItem.Text = language["MenuFilmoffen"].ToString();
            filmlisteSpeichernToolStripMenuItem.Text = language["MenuFilmspeichern"].ToString();
            filmlisteSpeichernUnterToolStripMenuItem.Text = language["MenuFilmspeichernunter"].ToString();
            filmExportierenToolStripMenuItem.Text = language["MenuFilmexport"].ToString();
            importAlteListeToolStripMenuItem.Text = language["MenuFilmimport"].ToString();
            beendenToolStripMenuItem.Text = language["MenuBeenden"].ToString();

            filmHinzufgenToolStripMenuItem.Text = language["MenuFilmhinzu"].ToString();
            filmBearbeitenToolStripMenuItem.Text = language["MenuFilmbearbeiten"].ToString();
            filmLschenToolStripMenuItem.Text = language["MenuFilmloeschen"].ToString();

            hilfeToolStripMenuItem.Text = language["MenuHilfe"].ToString();
            creditsToolStripMenuItem.Text = language["MenuCredits"].ToString();

            Filterlabel.Text = language["labelFilter"].ToString();
            Filmanzahllabel.Text = language["labelAnzahlFilme"].ToString();

            exportbutton.Text = language["buttonExport"].ToString();
            hinzubutton.Text = language["buttonHinzu"].ToString();
            speichernbutton.Text = language["buttonSpeichern"].ToString();
            schliessenbutton.Text = language["buttonBeenden"].ToString();
                        
        }

        private void setLanguage()
        {
            XmlTextReader reader = new XmlTextReader("language.xml");

            ArrayList neueFilme = new ArrayList();
            String Name = "", Wert = "";

            try
            {
                while (reader.Read())
                {
                    switch (reader.NodeType)
                    {
                        case XmlNodeType.Element:
                            Name = reader.Name;
                            break;
                        case XmlNodeType.Text:
                            Wert = reader.Value;
                            break;
                        case XmlNodeType.EndElement:
                            language.Add(Name, Wert);
                            break;
                    }
                }
            }
            catch (Exception) { }
        }

        private void FilmlisteForm_Resize(object sender, EventArgs e)
        {
            FilmdataGridView.Size = new Size(this.Size.Width - 30, this.Size.Height - 140);
        }

        private void FilmecheckBox_CheckedChanged(object sender, EventArgs e)
        {
            SuchFilterTextBox.Text = "";

            if (FilmecheckBox.Checked)
            {
                SeriencheckBox.Checked = false;

                FilmFilter.DataSource = FilmDatenSource();
                FilmdataGridView.DataSource = FilmFilter;

                if (Filme.Count != 0)
                {
                    FilmFilter.Filter = "Staffel = 0";
                }
            }
            else
            {
                FilmFilter.RemoveFilter();
            }
        }

        private void SeriencheckBox_CheckedChanged(object sender, EventArgs e)
        {
            SuchFilterTextBox.Text = "";

            if (SeriencheckBox.Checked)
            {
                FilmecheckBox.Checked = false;

                FilmFilter.DataSource = FilmDatenSource();
                FilmdataGridView.DataSource = FilmFilter;

                if (Filme.Count != 0)
                {
                    FilmFilter.Filter = "Staffel > 0";
                }
            }
            else
            {
                FilmFilter.RemoveFilter();
            }
        }

        private void webbutton_Click(object sender, EventArgs e)
        {
            if ((Filme.Count > 0) && (Reihe < Filme.Count)) {
                Film einFilm = (Film)Filme[Reihe];
                System.Diagnostics.Process.Start("http://www.imdb.de/find?s=tt&q=" + einFilm.titel);
            }
        }


    }
}