using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Filmverwaltung;
using System.IO;
using System.Xml;

namespace WindowsApplication1
{
    public partial class FilmverwaltungForm : Form
    {
        ArrayList Filme;
        FilmlisteForm Hauptprogramm;
        int bearbeiten = -1;
        Hashtable language;

        public FilmverwaltungForm(ArrayList F, FilmlisteForm H)
        {
            Filme = F;
            Hauptprogramm = H;
            InitializeComponent();
            comboBoxArt.SelectedIndex = 0;
        }


        private void speicherbutton_Click(object sender, EventArgs e)
        {
            if (textBoxTitel.Text != "")
            {
                Film einFilm = new Film();

                //Werte einlesen
                einFilm.titel = textBoxTitel.Text;
                //einFilm.art = (String)comboBoxArt.SelectedItem;
                einFilm.art = comboBoxArt.SelectedItem.ToString();
                einFilm.sprache = comboBoxSprache.SelectedItem.ToString();

                try
                {
                    einFilm.anzahl = int.Parse(AnzahlnumericUpDown.Value.ToString());
                }
                catch (Exception) {
                    MessageBox.Show(language["errorAnzahl"].ToString());
                    return;
                }
                einFilm.format = textBoxFormat.Text;
                einFilm.bewertung = bewertung;
                einFilm.beschreibung = textBox3.Text;

                if (bearbeiten == -1)
                    Hauptprogramm.Filme.Add(einFilm);
                else
                {
                    Hauptprogramm.Filme[bearbeiten] = einFilm;
                    bearbeiten = -1;
                }

                //Wenn es eine Serie ist
                if (SeriencheckBox.Checked)
                {
                    einFilm.staffel = (int)StaffelnumericUpDown.Value;
                    einFilm.episode = (int)EpisodenumericUpDown.Value;
                    einFilm.episodentitel = EpisodenTiteltextBox.Text;
                }
                else
                {
                    einFilm.staffel = 0;
                    einFilm.episode = 0;
                    einFilm.episodentitel = "";
                }

                Hauptprogramm.gespeichert = false;

                //Felder leeren
                textBoxTitel.Text = "";
                AnzahlnumericUpDown.Value = 1;
                textBoxFormat.Text = "";
                textBox3.Text = "";
                StaffelnumericUpDown.Value = 1;
                EpisodenumericUpDown.Value = 1;
                EpisodenTiteltextBox.Text = "";

/*
                StreamWriter dateis = new StreamWriter("Filme.txt");

                foreach (object s in Filme)
                {
                    Film speichern = (Film)s;
                    dateis.WriteLine("<Film>");
                    dateis.WriteLine("Titel=" + speichern.titel);
                    dateis.WriteLine("Art=" + speichern.art);
                    dateis.WriteLine("Anzahl=" + speichern.anzahl);
                    dateis.WriteLine("Format=" + speichern.format);
                    dateis.WriteLine("Bewertung=" + speichern.bewertung);
                    dateis.WriteLine("Beschreibung=" + speichern.beschreibung);
                    dateis.WriteLine("</Film>");
                    dateis.WriteLine(";-----------------");

                }
 
                dateis.Close();
 */
            }
            else MessageBox.Show(language["errorTitel"].ToString());
        }

        public int bewertung = 0;

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            bewertung = 1;
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            bewertung = 2;
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            bewertung = 3;
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            bewertung = 4;
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            bewertung = 5;
        }

        private void Filmverwaltung_Shown(object sender, EventArgs e)
        {
            
            
            //Datei einlesen
            /*
            try
            {
                Film einFilm = new Film();

                StreamReader dateil = File.OpenText(Application.StartupPath + "//Filme.txt");
                for (int i = 0; -1 != dateil.Peek(); i++) // Bei Peek -1 ist Datei zuende
                {
                    String zeile = dateil.ReadLine();
                    String[] zeile_s = zeile.Split('=');
//                    if (zeile[0] != ';')
                    {
                        if (zeile == "<Film>") { einFilm = new Film(); }
                        if (zeile == "</Film>") { Filme.Add(einFilm);  }
                        if (zeile_s[0] == "Titel") { einFilm.titel = zeile_s[1]; }
                        if (zeile_s[0] == "Art") { einFilm.art = zeile_s[1]; }
                        if (zeile_s[0] == "Anzahl") { einFilm.anzahl = int.Parse(zeile_s[1]); }
                        if (zeile_s[0] == "Format") { einFilm.format = zeile_s[1]; }
                        if (zeile_s[0] == "Bewertung") { einFilm.bewertung = int.Parse(zeile_s[1]); }
                        if (zeile_s[0] == "Beschreibung") { einFilm.beschreibung = zeile_s[1]; }
                   }

                }
            }
            catch (FileNotFoundException)
            {
                MessageBox.Show("Datei nicht gefunden!");
            }
             
             */
            


        }

        private void Filmlistbutton_Click(object sender, EventArgs e)
        {
            //MessageBox.Show("Anzahl Elemente in Film" + Filme.Count);
            //FilmlisteForm Filmliste = new FilmlisteForm(Filme);
            //Filmliste.Show();
        }

        public void datei_speichern(String dateiname, ArrayList speicherFilme)
        {
            XmlWriterSettings einstellungen = new XmlWriterSettings();
            einstellungen.Indent = false;
            einstellungen.OmitXmlDeclaration = true;
            Hauptprogramm.Text = "Filmverwaltung - " + dateiname;

            

            XmlWriter writer = XmlWriter.Create(dateiname, einstellungen);

            try
                {

                writer.WriteStartElement("Filmliste");
                foreach (object f in speicherFilme)
                {
                    Film speichern = (Film)f;
                    writer.WriteStartElement("Film");
                    writer.WriteElementString("Titel", speichern.titel);
                    writer.WriteElementString("Art", speichern.art);
                    writer.WriteElementString("Anzahl", speichern.anzahl.ToString());
                    writer.WriteElementString("Format", speichern.format);
                    writer.WriteElementString("Sprache", speichern.sprache);
                    writer.WriteElementString("Bewertung", speichern.bewertung.ToString());
                    writer.WriteElementString("Staffel", speichern.staffel.ToString());
                    writer.WriteElementString("Episode", speichern.episode.ToString());
                    writer.WriteElementString("Episodentitel", speichern.episodentitel.ToString());
                    writer.WriteElementString("Beschreibung", speichern.beschreibung);
                    writer.WriteEndElement();
                }
                writer.WriteEndElement();
                Hauptprogramm.gespeichert = true;
            }
            catch (Exception) { MessageBox.Show(language["errorExport"].ToString()); }
            finally { writer.Close(); }


        }

        public ArrayList datei_oeffnen(String dateiname)
        {
            XmlReader reader = XmlReader.Create(dateiname);

            ArrayList neueFilme = new ArrayList();

            try
            {
                reader.ReadStartElement("Filmliste");
                while (reader.IsStartElement())
                {
                    Film neuerFilm = new Film();
                    reader.ReadStartElement("Film");
                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Titel");
                        neuerFilm.titel = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.titel = "";
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Art");
                        neuerFilm.art = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.art = "";
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Anzahl");
                        neuerFilm.anzahl = int.Parse(reader.ReadString());
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.anzahl = 0;
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Format");
                        neuerFilm.format = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.format = "";
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Sprache");
                        neuerFilm.sprache = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.sprache = "";
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Bewertung");
                        neuerFilm.bewertung = int.Parse(reader.ReadString());
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.bewertung = 0;
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Staffel");
                        neuerFilm.staffel = int.Parse(reader.ReadString());
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.staffel = 0;
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Episode");
                        neuerFilm.episode = int.Parse(reader.ReadString());
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.episode = 0;
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Episodentitel");
                        neuerFilm.episodentitel = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.episodentitel = "";
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Beschreibung");
                        neuerFilm.beschreibung = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.beschreibung = "";
                    }

                    reader.ReadEndElement();
                    neueFilme.Add(neuerFilm);
                }
                reader.ReadEndElement();
                reader.Close();
            }
            catch (Exception) { MessageBox.Show(language["errorFileRead"].ToString()); }

            return neueFilme;
        }

        public ArrayList datei_oeffnenAlt(String dateiname)
        {
            XmlReader reader = XmlReader.Create(dateiname);

            ArrayList neueFilme = new ArrayList();

            try
            {
                reader.ReadStartElement("Filmliste");
                while (reader.IsStartElement())
                {
                    Film neuerFilm = new Film();
                    reader.ReadStartElement("Film");
                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Titel");
                        neuerFilm.titel = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.titel = "";
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Art");
                        neuerFilm.art = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.art = "";
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Anzahl");
                        neuerFilm.anzahl = int.Parse(reader.ReadString());
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.anzahl = 0;
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Format");
                        neuerFilm.format = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.format = "";
                    }

/*                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Sprache");
                        neuerFilm.sprache = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.sprache = "";
                    }
                    */

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Bewertung");
                        neuerFilm.bewertung = int.Parse(reader.ReadString());
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.bewertung = 0;
                    }

                    if (!reader.IsEmptyElement)
                    {
                        reader.ReadStartElement("Beschreibung");
                        neuerFilm.beschreibung = reader.ReadString();
                        reader.ReadEndElement();
                    }
                    else
                    {
                        reader.Read();
                        neuerFilm.beschreibung = "";
                    }

                    reader.ReadEndElement();

                    neuerFilm.sprache = "";
                    neuerFilm.staffel = 0;
                    neuerFilm.episode = 0;
                    neuerFilm.episodentitel = "";
                    
                    neueFilme.Add(neuerFilm);
                }
                reader.ReadEndElement();
                reader.Close();

            }
            catch (Exception) { MessageBox.Show(language["errorFileRead"].ToString()); }

            return neueFilme;
        }


        private void closebutton_Click(object sender, EventArgs e)
        {
            this.Close();
            Hauptprogramm.GridView_fuellen(Hauptprogramm.Filme);
            Hauptprogramm.Visible = true;
        }

        private void FilmverwaltungForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            Hauptprogramm.GridView_fuellen(Hauptprogramm.Filme);
            Hauptprogramm.Visible = true;
        }

        public void Filmbearbeiten(int Reihe)
        {
            bearbeiten = Reihe;
            speicherbutton.Enabled = false;
            Film einFilm = (Film)Hauptprogramm.Filme[Reihe];
            textBoxTitel.Text = einFilm.titel;
            comboBoxArt.Text = einFilm.art;
            //(String)comboBoxArt.SelectedItem = einFilm.art;
            AnzahlnumericUpDown.Value = einFilm.anzahl;

            textBoxFormat.Text = einFilm.format;
            bewertung = einFilm.bewertung;
            switch (bewertung)
            {
                case 1: radioButton1.Checked = true;
                    break;
                case 2: radioButton2.Checked = true;
                    break;
                case 3: radioButton3.Checked = true;
                    break;
                case 4: radioButton4.Checked = true;
                    break;
                case 5: radioButton5.Checked = true;
                    break;
            }
            textBox3.Text = einFilm.beschreibung ;

            if (einFilm.staffel != 0)
            {
                StaffelnumericUpDown.Value = einFilm.staffel;
                EpisodenumericUpDown.Value = einFilm.episode;
                EpisodenTiteltextBox.Text = einFilm.episodentitel;
                SeriencheckBox.Checked = true;
            }

            


        }

        private void FilmverwaltungForm_Load(object sender, EventArgs e)
        {
            language = Hauptprogramm.language;
            changeSize();

            ArrayList FilmSprache = new ArrayList();
            XmlReader reader = XmlReader.Create("sprache.xml");
            try
            {
                reader.ReadStartElement("Sprachen");
                while (reader.IsStartElement())
                {
                    reader.ReadStartElement("Sprache");
                    if (!reader.IsEmptyElement)
                    {
                        FilmSprache.Add(reader.ReadString());
                    }
                    else
                    {
                        reader.Read();
                    }
                    reader.ReadEndElement();
                }
                reader.ReadEndElement();
            }
            catch (Exception) { MessageBox.Show(language["errorSprachData"].ToString()); }
            comboBoxSprache.DataSource = FilmSprache;
            reader.Close();


            ArrayList FilmFormate = new ArrayList();
            reader = XmlReader.Create("medium.xml");
            try
            {
                reader.ReadStartElement("Medien");
                while (reader.IsStartElement())
                {
                    reader.ReadStartElement("Medium");
                    if (!reader.IsEmptyElement)
                    {
                        FilmFormate.Add(reader.ReadString());
                    }
                    else
                    {
                        reader.Read();
                    }
                    reader.ReadEndElement();
                }
                reader.ReadEndElement();
            }
            catch (Exception) { MessageBox.Show(language["errorMediaData"].ToString()); }
            comboBoxArt.DataSource = FilmFormate;

            setBeschriftungen();
            
        }

        private void buttonSpeichernClose_Click(object sender, EventArgs e)
        {
            speicherbutton.PerformClick();
            buttonClose.PerformClick();

        }

        public void setBeschriftungen()
        {

            Titellabel.Text = language["labelTitel"].ToString();
            Mediumlabel.Text = language["labelArt"].ToString();
            Anzahllabel.Text = language["labelAnzahl"].ToString();
            Formatlabel.Text = language["labelFormat"].ToString();
            Sprachelabel.Text = language["labelSprache"].ToString();
            Bewertunglabel.Text = language["labelBewertung"].ToString();
            Beschreibunglabel.Text = language["labelBeschreibung"].ToString();
            radioButton1.Text = language["labelBewertung1"].ToString();
            radioButton2.Text = language["labelBewertung2"].ToString();
            radioButton3.Text = language["labelBewertung3"].ToString();
            radioButton4.Text = language["labelBewertung4"].ToString();
            radioButton5.Text = language["labelBewertung5"].ToString();
            SeriencheckBox.Text = language["labelSerie"].ToString();
            Staffellabel.Text = language["labelStaffel"].ToString();
            Episodenlabel.Text = language["labelEpisode"].ToString();
            Episodentitellabel.Text = language["labelEpisodentitel"].ToString();

            buttonClose.Text = language["buttonBack"].ToString();
            speicherbutton.Text = language["buttonSpeichernWeiter"].ToString();
            buttonSpeichernClose.Text = language["buttonSpeichernBack"].ToString();

        }

        private void SeriencheckBox_CheckedChanged(object sender, EventArgs e)
        {
            changeSize();
        }

        private void changeSize()
        {
            if (SeriencheckBox.Checked)
            {
                panel2.Visible = true;
                this.Size = new Size(420, 465);
            }
            else
            {
                panel2.Visible = false;
                this.Size = new Size(420, 380);
            }
        }



    }

 

}